import discord
from cpl_discord.events import OnMemberUpdateABC

from bot_core.helper.event_checks import EventChecks
from modules.short_role_name.service.short_role_name_service import ShortRoleNameService


class ShortRoleNameOnMemberUpdateEvent(OnMemberUpdateABC):
    def __init__(self, service: ShortRoleNameService):
        OnMemberUpdateABC.__init__(self)
        self._service = service

    @EventChecks.check_is_ready
    async def on_member_update(self, before: discord.member.Member, after: discord.member.Member):
        if before.roles != after.roles or before.name != after.name or before.display_name != after.display_name:
            await self._service.check_short_role_names(after)
